# TODO: __pycache__ for python3-sip-devel
#
# Conditional build:
%bcond_without	python2	# CPython 2.x modules
%bcond_without	python3	# CPython 3.x modules

Summary:	Python bindings generator for C++ class libraries
Summary(pl.UTF-8):	Generator powiązań Pythona z bibliotekami klas C++
Name:		sip
Version:	4.19
Release:	1
Epoch:		2
License:	SIP (redistributable, see LICENSE) or GPL v2 or GPL v3
Group:		Development/Languages/Python
Source0:	http://downloads.sourceforge.net/pyqt/sip-%{version}.tar.gz
# Source0-md5:	be51a05065c9323b98a2ec2966c64e6a
Patch0:		%{name}-outoftree.patch
URL:		http://www.riverbankcomputing.com/software/sip/
BuildRequires:	libstdc++-devel
BuildRequires:	python-devel >= 1:2.3
BuildRequires:	python3-devel >= 1:3.2
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.167
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sipfilesdir	%{_datadir}/sip

%description
SIP generates Python bindings for C++ class libraries from a set of
class specification files. It supports Python v2 and v3.

%description -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Obsługiwany jest Python 2 i 3.

%package -n python-sip
Summary:	Python 2 module needed by SIP generated bindings
Summary(pl.UTF-8):	Moduł Pythona 2 wymagany przez wiązania wygenerowane przez SIP
Group:		Libraries/Python
Requires:	python-libs

%description -n python-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 2 runtime
library needed by all generated bindings.

%description -n python-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 2
potrzebną do uruchomienia wszystkich wygenerowanych powiązań.

%package -n python-sip-devel
Summary:	Python 2 development files needed to build bindings using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 2 potrzebne do budowania wiązań przy użyciu SIP-a
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	python-sip = %{epoch}:%{version}-%{release}
Requires:	python-devel >= 1:2.3

%description -n python-sip-devel
Python 2 development files needed to build bindings for C++ classes
using SIP.

%description -n python-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 2 potrzebne do budowania wiązań dla klas
C++ przy użyciu SIP-a.

%package -n python3-sip
Summary:	Python 3 module needed by SIP generated bindings
Summary(pl.UTF-8):	Moduł Pythona 3 wymagany przez wiązania wygenerowane przez SIP
Group:		Libraries/Python
Requires:	python3-libs

%description -n python3-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 3 runtime
library needed by all generated bindings.

%description -n python3-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 3
potrzebną do uruchomienia wszystkich wygenerowanych powiązań.

%package -n python3-sip-devel
Summary:	Python 3 development files needed to build bindings using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 3 potrzebne do budowania wiązań przy użyciu SIP-a
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	python3-sip = %{epoch}:%{version}-%{release}
Requires:	python3-devel >= 1:3.2

%description -n python3-sip-devel
Python 3 development files needed to build bindings for C++ classes
using SIP.

%description -n python3-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 3 potrzebne do budowania wiązań dla klas
C++ przy użyciu SIP-a.

%prep
%setup -q
%patch0 -p1

%build
# configure.py notes:
# - macros overrides must be last
# - cannot pass CXXFLAGS+="%{rpmcflags}" or so - builtin -O2 overrides rpmcflags

%if %{with python2}
install -d build-py2
cd build-py2
%{__python} ../configure.py \
	-b %{_bindir} \
	-e %{py_incdir} \
	-v %{_sipfilesdir} \
	-d %{py_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..
%endif

%if %{with python3}
install -d build-py3
cd build-py3
%{__python3} ../configure.py \
	-b %{_bindir} \
	-e %{py3_incdir} \
	-v %{_sipfilesdir} \
	-d %{py3_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sipfilesdir}

%if %{with python2}
%{__make} -C build-py2 install \
	DESTDIR=$RPM_BUILD_ROOT

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%endif

%if %{with python3}
%{__make} -C build-py3 install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE NEWS README doc/html
%attr(755,root,root) %{_bindir}/sip
%dir %{_sipfilesdir}

%if %{with python2}
%files -n python-sip
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/sip.so

%files -n python-sip-devel
%defattr(644,root,root,755)
%{py_sitedir}/sipconfig.py
%{py_sitedir}/sipconfig.py[co]
%{py_sitedir}/sipdistutils.py
%{py_sitedir}/sipdistutils.py[co]
%{py_sitedir}/sip.pyi
%{py_incdir}/sip.h
%endif

%if %{with python3}
%files -n python3-sip
%defattr(644,root,root,755)
%attr(755,root,root) %{py3_sitedir}/sip.so

%files -n python3-sip-devel
%defattr(644,root,root,755)
%{py3_sitedir}/sipconfig.py
%{py3_sitedir}/sipdistutils.py
%{py3_sitedir}/sip.pyi
%{py3_incdir}/sip.h
%endif
%changelog
* Sat Dec 31 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sip.git;a=log;h=master

* Sat Dec 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> cd55497
- up to 4.19

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 8613382
- python 3.6
- release 3 (by relup.sh)

* Sat Nov 19 2016 Jacek Konieczny <jajcus@jajcus.net> d6a42ff
- Fix internal dependencies

* Wed Oct 05 2016 Jakub Bogusz <qboosh@pld-linux.org> 0357c4e
- updated to 4.18.1

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 9778a2d
- release 2 (by relup.sh)

* Sun Nov 08 2015 Jakub Bogusz <qboosh@pld-linux.org> a0ffe2f
- updated to 4.17

* Mon Sep 14 2015 Elan Ruusamäe <glen@delfi.ee> bab1a35
- python3 rebuild
- release 2 (by relup.sh)

* Thu Aug 27 2015 Mateusz Korniak <matkor@pld-linux.org> 457cb35
- updated to 4.16.9

* Mon Apr 06 2015 Jakub Bogusz <qboosh@pld-linux.org> b58f7e9
- updated to 4.16.7

* Thu Mar 12 2015 Lukasz Masko <lmasko@pld-linux.org> 5805a32
- Up to 4.16.6.

* Wed Feb 25 2015 Elan Ruusamäe <glen@delfi.ee> d19e56d
- x32 rebuild
- release 3 (by relup.sh)

* Wed Oct 29 2014 Jakub Bogusz <qboosh@pld-linux.org> 1209df6
- one more fix in outoftree patch (VPATH support for moc rules, needed for PyQt4 out-of-tree build)
- release 2

* Tue Oct 28 2014 Jakub Bogusz <qboosh@pld-linux.org> d2c54cb
- updated to 4.16.4

* Tue Oct 28 2014 Jakub Bogusz <qboosh@pld-linux.org> 4c69315
- added outoftree patch to fix out-of-tree builds
- _sipfiles dir goes to sip package
- added python3 modules

* Thu Oct 16 2014 Jan Rękorajski <baggins@pld-linux.org> 756ecdc
- up to 4.16.3

* Fri Dec 27 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> dcec4ed
- up to 4.15.3

* Sun Dec 09 2012 Karol Krenski <charles@pld-linux.org> 2df49f7
- up to 4.14.2

* Sun Oct 14 2012 Jakub Bogusz <qboosh@pld-linux.org> 1c28206
- updated to 4.14; new Source0 URL

* Sun Jun 24 2012 Jakub Bogusz <qboosh@pld-linux.org> 3e2f755
- use __python macro

* Sat Jun 23 2012 Jakub Bogusz <qboosh@pld-linux.org> 58b54ce
- updated to 4.13.3

